Index: binaries/data/mods/public/simulation/templates/template_unit_champion.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/template_unit_champion.xml	(révision 16880)
+++ binaries/data/mods/public/simulation/templates/template_unit_champion.xml	(copie de travail)
@@ -2,7 +2,7 @@
 <Entity parent="template_unit">
   <Attack>
     <Capture>
-      <Value>8</Value>
+      <Value>7</Value>
       <MaxRange>4</MaxRange>
       <RepeatTime>1000</RepeatTime>
     </Capture>
Index: binaries/data/mods/public/simulation/templates/template_unit_hero.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/template_unit_hero.xml	(révision 16880)
+++ binaries/data/mods/public/simulation/templates/template_unit_hero.xml	(copie de travail)
@@ -1,5 +1,23 @@
 <?xml version="1.0" encoding="utf-8"?>
 <Entity parent="template_unit">
+  <Auras>
+    <AuraA>
+      <Type>garrison</Type>
+      <Affects>GarrisonHolder</Affects>
+      <Modifications>
+        <Capturable.GarrisonRegenRate> <Add>2</Add> </Capturable.GarrisonRegenRate>
+      </Modifications>
+      <AuraName>Hero Aura</AuraName>
+      <AuraDescription>When garrisoned in a structure, it galvanizes its defenders, +2 GarrisonRegenRate</AuraDescription>
+    </AuraA>    
+  </Auras>
+  <Attack> 
+    <Capture>
+      <Value>9</Value> 
+      <MaxRange>4</MaxRange> 
+      <RepeatTime>1000</RepeatTime> 
+    </Capture> 
+  </Attack>
   <Armour>
     <Hack>10.0</Hack>
     <Pierce>20.0</Pierce>
Index: binaries/data/mods/public/simulation/templates/units/brit_hero_boudicca.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/units/brit_hero_boudicca.xml	(révision 16880)
+++ binaries/data/mods/public/simulation/templates/units/brit_hero_boudicca.xml	(copie de travail)
@@ -8,9 +8,10 @@
         <UnitMotion.WalkSpeed> <Multiply>1.25</Multiply> </UnitMotion.WalkSpeed>
         <Attack.Ranged.Pierce> <Add>5</Add> </Attack.Ranged.Pierce>
         <Attack.Melee.Hack> <Add>5</Add> </Attack.Melee.Hack>
+        <Attack.Capture.Value> <Add>2</Add> </Attack.Capture.Value>
       </Modifications>
       <AuraName>Champion Army</AuraName>
-      <AuraDescription>+5 Attack and +25% Speed for Champion Units.</AuraDescription>
+      <AuraDescription>+5 Attack, +2 Capture and +25% Speed for Champion Units.</AuraDescription>
     </Aura1>
   </Auras>
   <Footprint replace="">
Index: binaries/data/mods/public/simulation/templates/units/brit_hero_boudicca_sword.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/units/brit_hero_boudicca_sword.xml	(révision 16880)
+++ binaries/data/mods/public/simulation/templates/units/brit_hero_boudicca_sword.xml	(copie de travail)
@@ -8,9 +8,10 @@
         <UnitMotion.WalkSpeed> <Multiply>1.25</Multiply> </UnitMotion.WalkSpeed>
         <Attack.Ranged.Pierce> <Add>5</Add> </Attack.Ranged.Pierce>
         <Attack.Melee.Hack> <Add>5</Add> </Attack.Melee.Hack>
+        <Attack.Capture.Value> <Add>2</Add> </Attack.Capture.Value>
       </Modifications>
       <AuraName>Champion Army</AuraName>
-      <AuraDescription>+5 Attack and +25% Speed for Champion Units.</AuraDescription>
+      <AuraDescription>+5 Attack, +2 Capture and +25% Speed for Champion Units.</AuraDescription>
     </Aura1>
   </Auras>
   <Identity>
Index: binaries/data/mods/public/simulation/templates/units/cart_hero_hannibal.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/units/cart_hero_hannibal.xml	(révision 16880)
+++ binaries/data/mods/public/simulation/templates/units/cart_hero_hannibal.xml	(copie de travail)
@@ -9,9 +9,10 @@
       <Modifications>
         <Attack.Ranged.Pierce> <Add>2</Add> </Attack.Ranged.Pierce>
         <Attack.Melee.Hack> <Add>2</Add> </Attack.Melee.Hack>
+        <Attack.Capture.Value> <Add>1</Add> </Attack.Capture.Value>
       </Modifications>
       <AuraName>Tactician Aura</AuraName>
-      <AuraDescription>All allied units +2 attack within vision range of him.</AuraDescription>
+      <AuraDescription>All allied units +2 Attack and +1 Capture within vision range of him.</AuraDescription>
       <OverlayIcon>art/textures/ui/session/auras/attack_bonus.png</OverlayIcon>
     </Aura1>
   </Auras>
Index: binaries/data/mods/public/simulation/templates/units/gaul_hero_vercingetorix.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/units/gaul_hero_vercingetorix.xml	(révision 16880)
+++ binaries/data/mods/public/simulation/templates/units/gaul_hero_vercingetorix.xml	(copie de travail)
@@ -8,9 +8,10 @@
       <Modifications>
         <Attack.Ranged.Pierce> <Add>2</Add> </Attack.Ranged.Pierce>
         <Attack.Melee.Hack> <Add>2</Add> </Attack.Melee.Hack>
+        <Attack.Capture.Value> <Add>1</Add> </Attack.Capture.Value>
       </Modifications>
       <AuraName>Hero Aura</AuraName>
-      <AuraDescription>+2 attack for all units within his aura.</AuraDescription>
+      <AuraDescription>+2 Attack and +1 Capture for all units within his aura.</AuraDescription>
       <OverlayIcon>art/textures/ui/session/auras/attack_bonus.png</OverlayIcon>
     </Aura1>
   </Auras>
Index: binaries/data/mods/public/simulation/templates/units/mace_hero_philip.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/units/mace_hero_philip.xml	(révision 16880)
+++ binaries/data/mods/public/simulation/templates/units/mace_hero_philip.xml	(copie de travail)
@@ -7,9 +7,10 @@
       <Modifications>
         <Attack.Ranged.Pierce> <Add>5</Add> </Attack.Ranged.Pierce>
         <Attack.Melee.Hack> <Add>5</Add> </Attack.Melee.Hack>
+	<Attack.Capture.Value> <Add>2</Add> </Attack.Capture.Value>
       </Modifications>
       <AuraName>Hero Aura</AuraName>
-      <AuraDescription>+5 Attack for Champion Units.</AuraDescription>
+      <AuraDescription>+5 Attack and +2 Capture for Champion Units.</AuraDescription>
     </Aura1>
   </Auras>
   <Identity>
Index: binaries/data/mods/public/simulation/templates/units/pers_hero_cyrus.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/units/pers_hero_cyrus.xml	(révision 16880)
+++ binaries/data/mods/public/simulation/templates/units/pers_hero_cyrus.xml	(copie de travail)
@@ -8,9 +8,10 @@
       <Modifications>
         <Attack.Ranged.Pierce> <Add>2</Add> </Attack.Ranged.Pierce>
         <Attack.Melee.Hack> <Add>2</Add> </Attack.Melee.Hack>
+        <Attack.Capture.Value> <Add>1</Add> </Attack.Capture.Value>
       </Modifications>
       <AuraName>Lead from the Front Aura</AuraName>
-      <AuraDescription>+2 attack for nearby cavalry units.</AuraDescription>
+      <AuraDescription>+2 Attack and +1 Capture for nearby cavalry units.</AuraDescription>
       <OverlayIcon>art/textures/ui/session/auras/attack_bonus.png</OverlayIcon>
     </Aura1>
   </Auras>
Index: binaries/data/mods/public/simulation/templates/units/rome_hero_marcellus.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/units/rome_hero_marcellus.xml	(révision 16880)
+++ binaries/data/mods/public/simulation/templates/units/rome_hero_marcellus.xml	(copie de travail)
@@ -8,9 +8,10 @@
       <Modifications>
         <Attack.Ranged.Pierce> <Add>5</Add> </Attack.Ranged.Pierce>
         <Attack.Melee.Hack> <Add>5</Add> </Attack.Melee.Hack>
+        <Attack.Capture.Value> <Add>2</Add> </Attack.Capture.Value>
       </Modifications>
       <AuraName>Sword of Rome Aura</AuraName>
-      <AuraDescription>+5 attack for Roman units within sight of him.</AuraDescription>
+      <AuraDescription>+5 Attack and +2 Capture for Roman units within sight of him.</AuraDescription>
       <OverlayIcon>art/textures/ui/session/auras/attack_bonus.png</OverlayIcon>
     </Aura1>
   </Auras>
Index: binaries/data/mods/public/simulation/templates/units/spart_hero_leonidas.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/units/spart_hero_leonidas.xml	(révision 16880)
+++ binaries/data/mods/public/simulation/templates/units/spart_hero_leonidas.xml	(copie de travail)
@@ -7,9 +7,10 @@
       <Affects>Spear</Affects>
       <Modifications>
         <Attack.Melee.Hack>   <Multiply>1.20</Multiply> </Attack.Melee.Hack>
+        <Attack.Capture.Value> <Add>1</Add> </Attack.Capture.Value>
       </Modifications>
       <AuraName>Last Stand Aura</AuraName>
-      <AuraDescription>+20% attack for nearby Hoplites and Spartiates.</AuraDescription>
+      <AuraDescription>+20% Attack and +1 Capture for nearby Hoplites and Spartiates.</AuraDescription>
       <OverlayIcon>art/textures/ui/session/auras/attack_bonus.png</OverlayIcon>
     </Aura1>
   </Auras>
@@ -16,7 +17,7 @@
   <Identity>
     <Civ>spart</Civ>
     <Lang>greek</Lang>
-	<GenericName>Leonidas I</GenericName>
+    <GenericName>Leonidas I</GenericName>
     <SpecificName>Leōnídēs</SpecificName>
     <History>The king of Sparta, who fought and died at the battle of Thermopylae in 480 BC. He successfully blocked the way of the huge Persian army through the narrow passage with his 7000 men, until Xerxes was made aware of a secret unobstructed path. Finding the enemy at his rear, Leonidas sent home most of his troops, choosing to stay behind with 300 hand-picked hoplites and win time for the others to withdraw.</History>
     <Icon>units/spart_hero_leonidas.png</Icon>