Index: art/actors/structures/carthaginians/wooden_tower.xml
===================================================================
--- art/actors/structures/carthaginians/wooden_tower.xml	(revision 16889)
+++ art/actors/structures/carthaginians/wooden_tower.xml	(working copy)
@@ -13,6 +13,9 @@
       </props>
       <textures>
         <texture file="props/palisade_main.png" name="baseTex"/>
+        <texture file="props/palisade_main_norm.png" name="normTex"/>
+        <texture file="props/palisade_main_spec.png" name="specTex"/>
+        <texture file="structural/ao/palisade_rocks_fort_ao.png" name="aoTex"/>
       </textures>
     </variant>
   </group>
@@ -24,5 +27,5 @@
       </props>
     </variant>
   </group>
-  <material>basic_trans.xml</material>
+  <material>player_trans_ao_parallax_spec.xml</material>
 </actor>
Index: art/actors/structures/celts/wooden_tower.xml
===================================================================
--- art/actors/structures/celts/wooden_tower.xml	(revision 16889)
+++ art/actors/structures/celts/wooden_tower.xml	(working copy)
@@ -13,6 +13,9 @@
       </props>
       <textures>
         <texture file="props/palisade_main.png" name="baseTex"/>
+        <texture file="props/palisade_main_norm.png" name="normTex"/>
+        <texture file="props/palisade_main_spec.png" name="specTex"/>
+        <texture file="structural/ao/palisade_rocks_fort_ao.png" name="aoTex"/>
       </textures>
     </variant>
   </group>
@@ -24,5 +27,5 @@
       </props>
     </variant>
   </group>
-  <material>basic_trans.xml</material>
+  <material>player_trans_ao_parallax_spec.xml</material>
 </actor>
Index: art/actors/structures/hellenes/wooden_tower.xml
===================================================================
--- art/actors/structures/hellenes/wooden_tower.xml	(revision 16889)
+++ art/actors/structures/hellenes/wooden_tower.xml	(working copy)
@@ -13,6 +13,9 @@
       </props>
       <textures>
         <texture file="props/palisade_main.png" name="baseTex"/>
+        <texture file="props/palisade_main_norm.png" name="normTex"/>
+        <texture file="props/palisade_main_spec.png" name="specTex"/>
+        <texture file="structural/ao/palisade_rocks_fort_ao.png" name="aoTex"/>
       </textures>
     </variant>
   </group>
@@ -24,5 +27,5 @@
       </props>
     </variant>
   </group>
-  <material>basic_trans.xml</material>
+  <material>player_trans_ao_parallax_spec.xml</material>
 </actor>
Index: art/actors/structures/iberians/wooden_tower.xml
===================================================================
--- art/actors/structures/iberians/wooden_tower.xml	(revision 16889)
+++ art/actors/structures/iberians/wooden_tower.xml	(working copy)
@@ -13,6 +13,9 @@
       </props>
       <textures>
         <texture file="props/palisade_main.png" name="baseTex"/>
+        <texture file="props/palisade_main_norm.png" name="normTex"/>
+        <texture file="props/palisade_main_spec.png" name="specTex"/>
+        <texture file="structural/ao/palisade_rocks_fort_ao.png" name="aoTex"/>
       </textures>
     </variant>
   </group>
@@ -24,5 +27,5 @@
       </props>
     </variant>
   </group>
-  <material>basic_trans.xml</material>
+  <material>player_trans_ao_parallax_spec.xml</material>
 </actor>
Index: art/actors/structures/mauryans/wooden_tower.xml
===================================================================
--- art/actors/structures/mauryans/wooden_tower.xml	(revision 16889)
+++ art/actors/structures/mauryans/wooden_tower.xml	(working copy)
@@ -13,6 +13,9 @@
       </props>
       <textures>
         <texture file="props/palisade_main.png" name="baseTex"/>
+        <texture file="props/palisade_main_norm.png" name="normTex"/>
+        <texture file="props/palisade_main_spec.png" name="specTex"/>
+        <texture file="structural/ao/palisade_rocks_fort_ao.png" name="aoTex"/>
       </textures>
     </variant>
   </group>
@@ -24,5 +27,5 @@
       </props>
     </variant>
   </group>
-  <material>basic_trans.xml</material>
+  <material>player_trans_ao_parallax_spec.xml</material>
 </actor>
Index: art/actors/structures/persians/wooden_tower.xml
===================================================================
--- art/actors/structures/persians/wooden_tower.xml	(revision 16889)
+++ art/actors/structures/persians/wooden_tower.xml	(working copy)
@@ -13,6 +13,9 @@
       </props>
       <textures>
         <texture file="props/palisade_main.png" name="baseTex"/>
+        <texture file="props/palisade_main_norm.png" name="normTex"/>
+        <texture file="props/palisade_main_spec.png" name="specTex"/>
+        <texture file="structural/ao/palisade_rocks_fort_ao.png" name="aoTex"/>
       </textures>
     </variant>
   </group>
@@ -24,5 +27,5 @@
       </props>
     </variant>
   </group>
-  <material>basic_trans.xml</material>
+  <material>player_trans_ao_parallax_spec.xml</material>
 </actor>
Index: art/actors/structures/ptolemies/wooden_tower.xml
===================================================================
--- art/actors/structures/ptolemies/wooden_tower.xml	(revision 16889)
+++ art/actors/structures/ptolemies/wooden_tower.xml	(working copy)
@@ -13,6 +13,9 @@
       </props>
       <textures>
         <texture file="props/palisade_main.png" name="baseTex"/>
+        <texture file="props/palisade_main_norm.png" name="normTex"/>
+        <texture file="props/palisade_main_spec.png" name="specTex"/>
+        <texture file="structural/ao/palisade_rocks_fort_ao.png" name="aoTex"/>
       </textures>
     </variant>
   </group>
@@ -24,5 +27,5 @@
       </props>
     </variant>
   </group>
-  <material>basic_trans.xml</material>
+  <material>player_trans_ao_parallax_spec.xml</material>
 </actor>
Index: art/actors/structures/romans/wooden_tower.xml
===================================================================
--- art/actors/structures/romans/wooden_tower.xml	(revision 16889)
+++ art/actors/structures/romans/wooden_tower.xml	(working copy)
@@ -13,6 +13,9 @@
       </props>
       <textures>
         <texture file="props/palisade_main.png" name="baseTex"/>
+        <texture file="props/palisade_main_norm.png" name="normTex"/>
+        <texture file="props/palisade_main_spec.png" name="specTex"/>
+        <texture file="structural/ao/palisade_rocks_fort_ao.png" name="aoTex"/>
       </textures>
     </variant>
   </group>
@@ -24,5 +27,5 @@
       </props>
     </variant>
   </group>
-    <material>basic_trans.xml</material>
+  <material>player_trans_ao_parallax_spec.xml</material>
 </actor>